FLTK 1.3.8: Fl_File_Input Class Reference

FLTK 1.3.8

Public Member Functions | Protected Member Functions | List of all members
Fl_File_Input Class Reference

This widget displays a pathname in a text input field. More...

`#include <Fl_File_Input.H>`

Inheritance diagram for Fl_File_Input:

## Public Member Functions
Fl_Boxtype | down_box () const
| Gets the box type used for the navigation bar.
void | down_box (Fl_Boxtype b)
| Sets the box type to use for the navigation bar.
Fl_Color | errorcolor () const
| Gets the current error color.
void | errorcolor (Fl_Color c)
| Sets the current error color to `c`.
| Fl_File_Input (int X, int Y, int W, int H, const char *L=0)
| Creates a new Fl_File_Input widget using the given position, size, and label string.
virtual int | handle (int event)
| Handle events in the widget.
const char * | value ()
| Returns the current value, which is a pointer to an internal buffer and is valid only until the next event is handled.
int | value (const char *str)
| Sets the value of the widget given a new string value.
int | value (const char *str, int len)
| Sets the value of the widget given a new string value and its length.
Public Member Functions inherited from Fl_Input
| Fl_Input (int, int, int, int, const char *=0)
| Creates a new Fl_Input widget using the given position, size, and label string.
int | handle (int)
| Handles the specified event.
Public Member Functions inherited from Fl_Input_
int | copy (int clipboard)
| Put the current selection into the clipboard.
int | copy_cuts ()
| Copies the yank buffer to the clipboard.
Fl_Color | cursor_color () const
| Gets the color of the cursor.
void | cursor_color (Fl_Color n)
| Sets the color of the cursor.
int | cut ()
| Deletes the current selection.
int | cut (int a, int b)
| Deletes all characters between index `a` and `b`.
int | cut (int n)
| Deletes the next `n` bytes rounded to characters before or after the cursor.
| Fl_Input_ (int, int, int, int, const char *=0)
| Creates a new Fl_Input_ widget.
Fl_Char | index (int i) const
| Returns the character at index `i`.
int | input_type () const
| Gets the input field type.
void | input_type (int t)
| Sets the input field type.
int | insert (const char *t, int l=0)
| Inserts text at the cursor position.
int | mark () const
| Gets the current selection mark.
int | mark (int m)
| Sets the current selection mark.
int | maximum_size () const
| Gets the maximum length of the input field in characters.
void | maximum_size (int m)
| Sets the maximum length of the input field in characters.
int | position () const
| Gets the position of the text cursor.
int | position (int p)
| Sets the cursor position and mark.
int | position (int p, int m)
| Sets the index for the cursor and mark.
int | readonly () const
| Gets the read-only state of the input field.
void | readonly (int b)
| Sets the read-only state of the input field.
int | replace (int b, int e, const char *text, int ilen=0)
| Deletes text from `b` to `e` and inserts the new string `text`.
void | resize (int, int, int, int)
| Changes the size of the widget.
int | shortcut () const
| Return the shortcut key associated with this widget.
void | shortcut (int s)
| Sets the shortcut key associated with this widget.
int | size () const
| Returns the number of bytes in value().
void | size (int W, int H)
| Sets the width and height of this widget.
int | static_value (const char *)
| Changes the widget text.
int | static_value (const char *, int)
| Changes the widget text.
int | tab_nav () const
| Gets whether the Tab key causes focus navigation in multiline input fields or not.
void | tab_nav (int val)
| Sets whether the Tab key does focus navigation, or inserts tab characters into Fl_Multiline_Input.
Fl_Color | textcolor () const
| Gets the color of the text in the input field.
void | textcolor (Fl_Color n)
| Sets the color of the text in the input field.
Fl_Font | textfont () const
| Gets the font of the text in the input field.
void | textfont (Fl_Font s)
| Sets the font of the text in the input field.
Fl_Fontsize | textsize () const
| Gets the size of the text in the input field.
void | textsize (Fl_Fontsize s)
| Sets the size of the text in the input field.
int | undo ()
| Undoes previous changes to the text buffer.
const char * | value () const
| Returns the text displayed in the widget.
int | value (const char *)
| Changes the widget text.
int | value (const char *, int)
| Changes the widget text.
int | wrap () const
| Gets the word wrapping state of the input field.
void | wrap (int b)
| Sets the word wrapping state of the input field.
| ~Fl_Input_ ()
| Destroys the widget.
Public Member Functions inherited from Fl_Widget
void | _clear_fullscreen ()
void | _set_fullscreen ()
void | activate ()
| Activates the widget.
unsigned int | active () const
| Returns whether the widget is active.
int | active_r () const
| Returns whether the widget and all of its parents are active.
Fl_Align | align () const
| Gets the label alignment.
void | align (Fl_Align alignment)
| Sets the label alignment.
long | argument () const
| Gets the current user data (long) argument that is passed to the callback function.
void | argument (long v)
| Sets the current user data (long) argument that is passed to the callback function.
virtual class Fl_Gl_Window * | as_gl_window ()
| Returns an Fl_Gl_Window pointer if this widget is an Fl_Gl_Window.
virtual Fl_Group * | as_group ()
| Returns an Fl_Group pointer if this widget is an Fl_Group.
virtual Fl_Window * | as_window ()
| Returns an Fl_Window pointer if this widget is an Fl_Window.
Fl_Boxtype | box () const
| Gets the box type of the widget.
void | box (Fl_Boxtype new_box)
| Sets the box type for the widget.
Fl_Callback_p | callback () const
| Gets the current callback function for the widget.
void | callback (Fl_Callback *cb)
| Sets the current callback function for the widget.
void | callback (Fl_Callback *cb, void *p)
| Sets the current callback function for the widget.
void | callback (Fl_Callback0 *cb)
| Sets the current callback function for the widget.
void | callback (Fl_Callback1 *cb, long p=0)
| Sets the current callback function for the widget.
unsigned int | changed () const
| Checks if the widget value changed since the last callback.
void | clear_active ()
| Marks the widget as inactive without sending events or changing focus.
void | clear_changed ()
| Marks the value of the widget as unchanged.
void | clear_damage (uchar c=0)
| Clears or sets the damage flags.
void | clear_output ()
| Sets a widget to accept input.
void | clear_visible ()
| Hides the widget.
void | clear_visible_focus ()
| Disables keyboard focus navigation with this widget.
Fl_Color | color () const
| Gets the background color of the widget.
void | color (Fl_Color bg)
| Sets the background color of the widget.
void | color (Fl_Color bg, Fl_Color sel)
| Sets the background and selection color of the widget.
Fl_Color | color2 () const
| For back compatibility only.
void | color2 (unsigned a)
| For back compatibility only.
int | contains (const Fl_Widget *w) const
| Checks if w is a child of this widget.
void | copy_label (const char *new_label)
| Sets the current label.
void | copy_tooltip (const char *text)
| Sets the current tooltip text.
uchar | damage () const
| Returns non-zero if draw() needs to be called.
void | damage (uchar c)
| Sets the damage bits for the widget.
void | damage (uchar c, int x, int y, int w, int h)
| Sets the damage bits for an area inside the widget.
int | damage_resize (int, int, int, int)
| Internal use only.
void | deactivate ()
| Deactivates the widget.
Fl_Image * | deimage ()
| Gets the image that is used as part of the widget label.
const Fl_Image * | deimage () const
void | deimage (Fl_Image &img)
| Sets the image to use as part of the widget label.
void | deimage (Fl_Image *img)
| Sets the image to use as part of the widget label.
void | do_callback ()
| Calls the widget callback.
void | do_callback (Fl_Widget *o, long arg)
| Calls the widget callback.
void | do_callback (Fl_Widget *o, void *arg=0)
| Calls the widget callback.
virtual void | draw ()=0
| Draws the widget.
void | draw_label (int, int, int, int, Fl_Align) const
| Draws the label in an arbitrary bounding box with an arbitrary alignment.
int | h () const
| Gets the widget height.
virtual int | handle (int event)
| Handles the specified event.
virtual void | hide ()
| Makes a widget invisible.
Fl_Image * | image ()
| Gets the image that is used as part of the widget label.
const Fl_Image * | image () const
void | image (Fl_Image &img)
| Sets the image to use as part of the widget label.
void | image (Fl_Image *img)
| Sets the image to use as part of the widget label.
int | inside (const Fl_Widget *wgt) const
| Checks if this widget is a child of `wgt`.
int | is_label_copied () const
| Returns whether the current label was assigned with copy_label().
const char * | label () const
| Gets the current label text.
void | label (const char *text)
| Sets the current label pointer.
void | label (Fl_Labeltype a, const char *b)
| Shortcut to set the label text and type in one call.
Fl_Color | labelcolor () const
| Gets the label color.
void | labelcolor (Fl_Color c)
| Sets the label color.
Fl_Font | labelfont () const
| Gets the font to use.
void | labelfont (Fl_Font f)
| Sets the font to use.
Fl_Fontsize | labelsize () const
| Gets the font size in pixels.
void | labelsize (Fl_Fontsize pix)
| Sets the font size in pixels.
Fl_Labeltype | labeltype () const
| Gets the label type.
void | labeltype (Fl_Labeltype a)
| Sets the label type.
void | measure_label (int &ww, int &hh) const
| Sets width ww and height hh accordingly with the label size.
unsigned int | output () const
| Returns if a widget is used for output only.
Fl_Group * | parent () const
| Returns a pointer to the parent widget.
void | parent (Fl_Group *p)
| Internal use only - "for hacks only".
void | position (int X, int Y)
| Repositions the window or widget.
void | redraw ()
| Schedules the drawing of the widget.
void | redraw_label ()
| Schedules the drawing of the label.
virtual void | resize (int x, int y, int w, int h)
| Changes the size or position of the widget.
Fl_Color | selection_color () const
| Gets the selection color.
void | selection_color (Fl_Color a)
| Sets the selection color.
void | set_active ()
| Marks the widget as active without sending events or changing focus.
void | set_changed ()
| Marks the value of the widget as changed.
void | set_output ()
| Sets a widget to output only.
void | set_visible ()
| Makes the widget visible.
void | set_visible_focus ()
| Enables keyboard focus navigation with this widget.
virtual void | show ()
| Makes a widget visible.
void | size (int W, int H)
| Changes the size of the widget.
int | take_focus ()
| Gives the widget the keyboard focus.
unsigned int | takesevents () const
| Returns if the widget is able to take events.
int | test_shortcut ()
| Returns true if the widget's label contains the entered '&x' shortcut.
const char * | tooltip () const
| Gets the current tooltip text.
void | tooltip (const char *text)
| Sets the current tooltip text.
Fl_Window * | top_window () const
| Returns a pointer to the top-level window for the widget.
Fl_Window * | top_window_offset (int &xoff, int &yoff) const
| Finds the x/y offset of the current widget relative to the top-level window.
uchar | type () const
| Gets the widget type.
void | type (uchar t)
| Sets the widget type.
int | use_accents_menu ()
| Returns non zero if MAC_USE_ACCENTS_MENU flag is set, 0 otherwise.
void * | user_data () const
| Gets the user data for this widget.
void | user_data (void *v)
| Sets the user data for this widget.
unsigned int | visible () const
| Returns whether a widget is visible.
unsigned int | visible_focus ()
| Checks whether this widget has a visible focus.
void | visible_focus (int v)
| Modifies keyboard focus navigation.
int | visible_r () const
| Returns whether a widget and all its parents are visible.
int | w () const
| Gets the widget width.
Fl_When | when () const
| Returns the conditions under which the callback is called.
void | when (uchar i)
| Sets the flags used to decide when a callback is called.
Fl_Window * | window () const
| Returns a pointer to the nearest parent window up the widget hierarchy.
int | x () const
| Gets the widget position in its window.
int | y () const
| Gets the widget position in its window.
virtual | ~Fl_Widget ()
| Destroys the widget.

## Protected Member Functions
virtual void | draw ()
| Draws the file input widget.
Protected Member Functions inherited from Fl_Input
void | draw ()
| Draws the widget.
Protected Member Functions inherited from Fl_Input_
void | drawtext (int, int, int, int)
| Draws the text in the passed bounding box.
void | handle_mouse (int, int, int, int, int keepmark=0)
| Handles mouse clicks and mouse moves.
int | handletext (int e, int, int, int, int)
| Handles all kinds of text field related events.
int | line_end (int i) const
| Finds the end of a line.
int | line_start (int i) const
| Finds the start of a line.
int | linesPerPage ()
void | maybe_do_callback ()
int | up_down_position (int, int keepmark=0)
| Moves the cursor to the column given by `up_down_pos`.
int | word_end (int i) const
| Finds the end of a word.
int | word_start (int i) const
| Finds the start of a word.
int | xscroll () const
int | yscroll () const
void | yscroll (int yOffset)
Protected Member Functions inherited from Fl_Widget
void | clear_flag (unsigned int c)
| Clears a flag in the flags mask.
void | draw_backdrop () const
| If FL_ALIGN_IMAGE_BACKDROP is set, the image or deimage will be drawn.
void | draw_box () const
| Draws the widget box according its box style.
void | draw_box (Fl_Boxtype t, Fl_Color c) const
| Draws a box of type t, of color c at the widget's position and size.
void | draw_box (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color c) const
| Draws a box of type t, of color c at the position X,Y and size W,H.
void | draw_focus ()
| draws a focus rectangle around the widget
void | draw_focus (Fl_Boxtype t, int x, int y, int w, int h) const
| Draws a focus box for the widget at the given position and size.
void | draw_label () const
| Draws the widget's label at the defined label position.
void | draw_label (int, int, int, int) const
| Draws the label in an arbitrary bounding box.
| Fl_Widget (int x, int y, int w, int h, const char *label=0L)
| Creates a widget at the given position and size.
unsigned int | flags () const
| Gets the widget flags mask.
void | h (int v)
| Internal use only.
void | set_flag (unsigned int c)
| Sets a flag in the flags mask.
void | w (int v)
| Internal use only.
void | x (int v)
| Internal use only.
void | y (int v)
| Internal use only.

## Additional Inherited Members
Static Public Member Functions inherited from Fl_Widget
static void | default_callback (Fl_Widget *cb, void *d)
| The default callback for all widgets that don't set a callback.
static unsigned int | label_shortcut (const char *t)
| Returns the Unicode value of the '&x' shortcut in a given text.
static int | test_shortcut (const char *, const bool require_alt=false)
| Returns true if the given text `t` contains the entered '&x' shortcut.
Protected Types inherited from Fl_Widget
enum | { INACTIVE = 1<<0 , INVISIBLE = 1<<1 , OUTPUT = 1<<2 , NOBORDER = 1<<3 , FORCE_POSITION = 1<<4 , NON_MODAL = 1<<5 , SHORTCUT_LABEL = 1<<6 , CHANGED = 1<<7 , OVERRIDE = 1<<8 , VISIBLE_FOCUS = 1<<9 , COPIED_LABEL = 1<<10 , CLIP_CHILDREN = 1<<11 , MENU_WINDOW = 1<<12 , TOOLTIP_WINDOW = 1<<13 , MODAL = 1<<14 , NO_OVERLAY = 1<<15 , GROUP_RELATIVE = 1<<16 , COPIED_TOOLTIP = 1<<17 , FULLSCREEN = 1<<18 , MAC_USE_ACCENTS_MENU = 1<<19 , USERFLAG3 = 1<<29 , USERFLAG2 = 1<<30 , USERFLAG1 = 1<<31 }
| flags possible values enumeration. More...

## Detailed Description

This widget displays a pathname in a text input field.

A navigation bar located above the input field allows the user to navigate upward in the directory tree. You may want to handle FL_WHEN_CHANGED events for tracking text changes and also FL_WHEN_RELEASE for button release when changing to parent dir. FL_WHEN_RELEASE callback won't be called if the directory clicked is the same as the current one.

P

Note
  As all Fl_Input derived objects, Fl_File_Input may call its callback when losing focus (see FL_UNFOCUS) to update its state like its cursor shape. One resulting side effect is that you should call clear_changed() early in your callback to avoid reentrant calls if you plan to show another window or dialog box in the callback.

## Constructor & Destructor Documentation

## ◆ Fl_File_Input()

Fl_File_Input::Fl_File_Input | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | const char * | L = `0`
| ) |  |

Creates a new Fl_File_Input widget using the given position, size, and label string.

The default boxtype is FL_DOWN_BOX.

Parameters

  [in] | X,Y,W,H | position and size of the widget
  [in] | L | widget label, default is no label

## Member Function Documentation

## ◆ down_box()

void Fl_File_Input::down_box | ( | Fl_Boxtype | b | ) |
| inline

Sets the box type to use for the navigation bar.

## ◆ draw()

void Fl_File_Input::draw | ( | void |  | ) |
| protectedvirtual

Draws the file input widget.

Implements Fl_Widget.

## ◆ errorcolor()

Fl_Color Fl_File_Input::errorcolor | ( |  | ) | const
| inline

Gets the current error color.

Todo:
  Better docs for Fl_File_Input::errorcolor() - is it even used?

## ◆ handle()

int Fl_File_Input::handle | ( | int | event | ) |
| virtual

Handle events in the widget.

Return non zero if event is handled.

Parameters

  [in] | event |

Reimplemented from Fl_Widget.

## ◆ value() [1/2]

int Fl_File_Input::value | ( | const char * | str | ) |

Sets the value of the widget given a new string value.

Returns non 0 on success.

Parameters

  [in] | str | new string value

## ◆ value() [2/2]

int Fl_File_Input::value | ( | const char * | str,
|  | int | len
| ) |  |

Sets the value of the widget given a new string value and its length.

Returns non 0 on success.

Parameters

  [in] | str | new string value
  [in] | len | lengh of value

The documentation for this class was generated from the following files:

- Fl_File_Input.H
- Fl_File_Input.cxx

- Copyright © 1998-2021 by Bill Spitzak and others.